src/mobile/server/api/urls.py
from django.conf.urls import url
from django.conf.urls.static import static

from higo import settings_dev as settings

import api.views_coupon as svc_coupon
import api.views_customer as svc_customer
import api.views_food as svc_food
import api.views_location as svc_location
import api.views_restaurant as svc_restaurant
import api.views_topic as svc_topic
import api.views_setting as svc_setting
import api.views_reservation as svc_reserve
import api.views_point as svc_point
import api.views_prize as svc_prize

urlpatterns = [
                  # --------------------------------------------------------
                  # ======================= SETTINGS =======================
                  # --------------------------------------------------------
                  url(r'^api/setting/getlist$', svc_setting.get_settings_list),
                  url(r'^api/setting/get_by_code$', svc_setting.get_setting_by_code),

                  # -------------------------------------------------------
                  # ======================= COUPONS =======================
                  # -------------------------------------------------------
                  # Coupon Details
                  url(r'^api/coupon_dtl/getlist$', svc_coupon.get_coupon_details_list),
                  url(r'^api/coupon_dtl/getinfo$', svc_coupon.get_coupon_detail_by_id),
                  url(r'^api/coupon_dtl/get_by_condition$', svc_coupon.get_coupon_detail_by_condition),
                  url(r'^api/coupon_dtl/insert$', svc_coupon.insert_coupon_detail),
                  url(r'^api/coupon_dtl/update$', svc_coupon.update_coupon_detail),
                  url(r'^api/coupon_dtl/delete$', svc_coupon.delete_coupon_detail),

                  # Coupons
                  url(r'^api/coupon/getlist$', svc_coupon.get_coupons_list),
                  url(r'^api/coupon/getlist_ctm$', svc_coupon.get_coupon_list_ctm),
                  url(r'^api/coupon/getinfo$', svc_coupon.get_coupon_by_id),
                  url(r'^api/coupon/get_by_condition$', svc_coupon.get_coupon_by_condition),
                  url(r'^api/coupon/insert$', svc_coupon.insert_coupon),
                  url(r'^api/coupon/update$', svc_coupon.update_coupon),
                  url(r'^api/coupon/delete$', svc_coupon.delete_coupon),
                  url(r'^api/coupon/getlist_by_cus_id', svc_coupon.get_coupon_list_with_cus_id),

                  # ---------------------------------------------------------
                  # ======================= CUSTOMERS =======================
                  # ---------------------------------------------------------
                  # Customer Coupons
                  url(r'^api/cus_cpn/getlist$', svc_customer.get_customer_coupons_list),
                  url(r'^api/cus_cpn/getinfo$', svc_customer.get_customer_coupon_by_id),
                  url(r'^api/cus_cpn/get_by_condition$', svc_customer.get_customer_coupon_by_condition),
                  url(r'^api/cus_cpn/insert$', svc_customer.insert_customer_coupon),
                  url(r'^api/cus_cpn/update$', svc_customer.update_customer_coupon),
                  url(r'^api/cus_cpn/delete$', svc_customer.delete_customer_coupon),

                  # Customers
                  url(r'^api/cus/getlist$', svc_customer.get_customers_list),
                  url(r'^api/cus/getinfo$', svc_customer.get_customer_by_id),
                  url(r'^api/cus/get_by_condition$', svc_customer.get_customer_by_condition),
                  url(r'^api/cus/insert$', svc_customer.insert_customer),
                  url(r'^api/cus/update$', svc_customer.update_customer),
                  url(r'^api/cus/delete$', svc_customer.delete_customer),

                  # Devices
                  url(r'^api/device/get_notify$', svc_customer.get_push_notify),
                  url(r'^api/device/set_notify$', svc_customer.set_push_notify),

                  # -----------------------------------------------------
                  # ======================= FOODS     =======================
                  # -----------------------------------------------------
                  # Food category
                  url(r'^api/food_cat/getlist$', svc_food.get_food_category_list),
                  url(r'^api/food_cat/getinfo$', svc_food.get_food_by_id),
                  url(r'^api/food_cat/get_by_condition$', svc_food.get_food_cat_by_condition),
                  url(r'^api/food_cat/insert$', svc_food.insert_food),
                  url(r'^api/food_cat/update$', svc_food.update_food),
                  url(r'^api/food_cat/delete$', svc_food.delete_food),

                  # Food Type
                  url(r'^api/food_type/getlist$', svc_food.get_food_types_list),
                  url(r'^api/food_type/getinfo$', svc_food.get_food_type_by_id),
                  url(r'^api/food_type/get_by_condition$', svc_food.get_food_type_by_condition),
                  url(r'^api/food_type/insert$', svc_food.insert_food_type),
                  url(r'^api/food_type/update$', svc_food.update_food_type),
                  url(r'^api/food_type/delete$', svc_food.delete_food_type),

                  # Food Price
                  url(r'^api/food_price/getlist$', svc_food.get_food_prices_list),
                  url(r'^api/food_price/getinfo$', svc_food.get_food_price_by_id),
                  url(r'^api/food_price/get_by_condition$', svc_food.get_food_price_by_condition),
                  url(r'^api/food_price/insert$', svc_food.insert_food_price),
                  url(r'^api/food_price/update$', svc_food.update_food_price),
                  url(r'^api/food_price/delete$', svc_food.delete_food_price),

                  # Food
                  url(r'^api/food/getlist$', svc_food.get_foods_list),
                  url(r'^api/food/getinfo$', svc_food.get_food_by_id),
                  url(r'^api/food/get_by_condition$', svc_food.get_food_by_condition),
                  url(r'^api/food/getlist_by_cat$', svc_food.get_foods_by_category),
                  url(r'^api/food/getlist_by_multi_cat$', svc_food.get_foods_by_multi_categories),
                  url(r'^api/food/insert$', svc_food.insert_food),
                  url(r'^api/food/update$', svc_food.update_food),
                  url(r'^api/food/delete$', svc_food.delete_food),

                  # -----------------------------------------------------
                  # ======================= ITEMS =======================
                  # -----------------------------------------------------


                  # ---------------------------------------------------------
                  # ======================= LOCATIONS =======================
                  # ---------------------------------------------------------
                  # Areas
                  url(r'^api/area/getlist$', svc_location.get_areas_list),
                  url(r'^api/area/getinfo$', svc_location.get_area_by_id),
                  url(r'^api/area/get_by_condition$', svc_location.get_area_by_condition),

                  # Stations
                  url(r'^api/station/getlist$', svc_location.get_stations_list),
                  url(r'^api/station/getinfo$', svc_location.get_station_by_id),
                  url(r'^api/station/get_by_condition$', svc_location.get_station_by_condition),

                  # ------------------------------------------------------
                  # ======================= POINTS =======================
                  # ------------------------------------------------------
                  # Customer Points
                  url(r'^api/cus_point/getlist$', svc_point.get_customer_points_list),
                  url(r'^api/cus_point/getinfo$', svc_point.get_customer_point_by_id),
                  url(r'^api/cus_point/insert$', svc_point.insert_customer_point),
                  url(r'^api/cus_point/update$', svc_point.update_customer_point),
                  url(r'^api/cus_point/delete$', svc_point.delete_customer_point),
                  url(r'^api/cus_point/use_qr_code$', svc_point.use_point_by_qr_code),

                  # Restaurant Points
                  url(r'^api/res_point/getlist$', svc_point.get_restaurant_points_list),
                  url(r'^api/res_point/getinfo$', svc_point.get_restaurant_point_by_id),
                  url(r'^api/res_point/insert$', svc_point.insert_restaurant_point),
                  url(r'^api/res_point/update$', svc_point.update_restaurant_point),
                  url(r'^api/res_point/delete$', svc_point.delete_restaurant_point),

                  # ------------------------------------------------------
                  # ======================= PRIZES =======================
                  # ------------------------------------------------------
                  # Customer Prizes
                  url(r'^api/cus_prize/getlist$', svc_prize.get_customer_prizes_list),
                  url(r'^api/cus_prize/getinfo$', svc_prize.get_customer_prize_by_id),
                  url(r'^api/cus_prize/insert$', svc_prize.insert_customer_prize),
                  url(r'^api/cus_prize/update$', svc_prize.update_customer_prize),
                  url(r'^api/cus_prize/use_prize$', svc_prize.cus_choose_prize),
                  url(r'^api/cus_prize/delete$', svc_prize.delete_customer_prize),

                  # Prizes
                  url(r'^api/prize/getlist$', svc_prize.get_prizes_list),
                  url(r'^api/prize/getinfo$', svc_prize.get_prize_by_id),
                  url(r'^api/prize/insert$', svc_prize.insert_prize),
                  url(r'^api/prize/update$', svc_prize.update_prize),
                  url(r'^api/prize/delete$', svc_prize.delete_prize),

                  # # ------------------------------------------------------------

src/mobile/server/foods/urls.py
from django.conf.urls import url, include
import foods.views as services

urlpatterns = [
    # ---------------------------------------------------------
    # ======================= FOODS ==========================
    # ---------------------------------------------------------
    # List
    url(r'^cms/foods/list/$', services.load_food_list, name='foods_list'),
    url(r'^foods_list_json/$', services.get_food_list_as_json, name='get_foods_list_as_json'),
    # Insert
    url(r'^cms/foods/add/$', services.add_foods, name='add_foods'),
    # edit
    url(r'^cms/foods/edit/([\d\D]+)/$', services.edit_foods, name='edit_foods'),
    # delete
    url(r'^cms/foods/delete/([\d\D]+)/$', services.delete_foods, name='delete_foods'),
    # ---------------------------------------------------------
    # =================== FOODS CATEGORY=======================
    # ---------------------------------------------------------
    # List     
    url(r'^cms/foods_cat/list/$', services.load_list_foods_cat_page, name='foods_cat_list'),
    url(r'^foods_cat_list_json/$', services.get_list_foods_cat_as_json, name='get_foods_cat_list_as_json'),
    # Insert
    url(r'^cms/foods_cat/add/$', services.add_foods_cat, name='add_foods_cat'),
    # edit
    url(r'^cms/foods_cat/edit/([\d\D]+)/$', services.edit_foods_cat, name='edit_foods_cat'),
    # delete
    url(r'^cms/foods_cat/delete/([\d\D]+)/$', services.delete_foods_cat, name='delete_foods_cat'),
    # check duplicate
    # url(r'^cms/foods/check_dup_name/$', services.check_duplicate_food_name, name='check_duplicate_food_name'),
]

src/mobile/server/higo/urls.py
from django.conf.urls import url, include
from django.contrib import admin
import commonmodels.views

# Overrides the default 400 handler django.views.defaults.bad_request
from utils import constants

handler400 = 'commonmodels.views.bad_request'

# Overrides the default 403 handler django.views.defaults.permission_denied
handler403 = 'commonmodels.views.permission_denied'

# Overrides the default 404 handler django.views.defaults.page_not_found
handler404 = 'commonmodels.views.page_not_found'

# Overrides the default 500 handler django.views.defaults.server_error
handler500 = 'commonmodels.views.server_error'

urlpatterns = [
    url(r'^$', commonmodels.views.api_home),
    url(r'^admin/', admin.site.urls),

    url(r'^', include('api.urls')),
    url(r'^', include('commonmodels.urls')),
    url(r'^', include('coupons.urls')),
    url(r'^', include('customers.urls')),
    url(r'^', include('foods.urls')),
    url(r'^', include('items.urls')),
    url(r'^', include('restaurants.urls')),
    url(r'^', include('suppliers.urls')),
    url(r'^', include('topics.urls')),
    url(r'^', include('locations.urls')),
    url(r'^', include('login.urls')),

    # Internationalization
    url(r'^i18n/', include('django.conf.urls.i18n')),
]

# if constants.DEBUG is False:
#     from django.contrib.staticfiles.urls import staticfiles_urlpatterns
#     urlpatterns += staticfiles_urlpatterns()

src/mobile/server/foods/forms.py
from django import forms
from django.core.validators import MaxValueValidator
from django.forms import ModelChoiceField

from commonmodels.models import Foods, FoodCategories, FoodTypes
from utils import constants as const


# Make category list
class CategoryModelChoiceField(ModelChoiceField):
    def label_from_instance(self, obj):
        try:
            return obj.name
        except AttributeError:
            return obj.name


class TypeModelChoiceField(ModelChoiceField):
    def label_from_instance(self, obj):
        try:
            return obj.name
        except AttributeError:
            return obj.name


# Food add new form
class FoodInfoForm(forms.ModelForm):
    category = CategoryModelChoiceField(
        queryset=None, empty_label=None, required=True, widget=forms.Select(attrs={'class': 'form-control'}))

    type = TypeModelChoiceField(
        queryset=None, empty_label=None, required=True, widget=forms.Select(attrs={'class': 'form-control'}))

    name = forms.CharField(
        widget=forms.TextInput(attrs={'class': 'form-control', 'required': 'required'}),
        max_length=50, error_messages={'required': 'This field is required.'})

    name_cn = forms.CharField(
        widget=forms.TextInput(attrs={'class': 'form-control', 'required': 'required'}),
        max_length=50, error_messages={'required': 'This field is required.'})

    price = forms.DecimalField(
        widget=forms.TextInput(attrs={'class': 'form-control cms_form_decimal', 'required': 'required',
                                      'maxlength': 19}),
        error_messages={'required': 'This field is required.'})

    description = forms.CharField(
        widget=forms.Textarea(attrs={'class': 'form-control', 'rows': 3}), max_length=2000, required=False)

    description_cn = forms.CharField(
        widget=forms.Textarea(attrs={'class': 'form-control', 'rows': 3}), max_length=2000, required=False)

    start_time = forms.TimeField(
        required=True,
        widget=forms.TextInput(
            attrs={'pattern': '([01]?[0-9]|2[0-3])(:[0-5][0-9])',
                   'class': 'form-control form-control-inline input-medium cms-time-picker'}))

    end_time = forms.TimeField(
        required=True,
        widget=forms.TextInput(
            attrs={'pattern': '([01]?[0-9]|2[0-3])(:[0-5][0-9])',
                   'class': 'form-control form-control-inline input-medium cms-time-picker'}))

    week_days = forms.MultipleChoiceField(
        choices=const.CMS_WEEK_DAYS, required=False, widget=forms.CheckboxSelectMultiple(
            attrs={'class': 'cms_week_days'}))

    current_order = forms.IntegerField(
        widget=forms.TextInput(attrs={'class': 'form-control cms_form_number', 'maxlength': 11}), required=False)

    quantity_per_day = forms.IntegerField(
        widget=forms.TextInput(attrs={'class': 'form-control cms_form_number', 'maxlength': 11}), required=False)

    hash_tags = forms.CharField(
        widget=forms.TextInput(attrs={'class': 'form-control'}), max_length=200, required=False)

    class Meta:
        model = Foods
        fields = (
            'category', 'type', 'name', 'name_cn', 'price', 'description', 'description_cn',
            'start_time', 'end_time', 'current_order', 'quantity_per_day', 'hash_tags', 'week_days'
        )

    def __init__(self, *args, **kwargs):
        super(FoodInfoForm, self).__init__(*args, **kwargs)
        self.fields['category'].queryset = FoodCategories.objects.filter(is_delete=const.ACTIVE_FLAG)
        self.fields['type'].queryset = FoodTypes.objects.filter(is_delete=const.ACTIVE_FLAG)
        self.fields['hash_tags'].initial = '#food '
        self.fields['week_days'].initial = [1,2,3,4,5,6,7]
        self.fields['current_order'].initial = 0
        self.fields['quantity_per_day'].initial = 1000
        self.fields['start_time'].initial = '00:00'
        self.fields['end_time'].initial = '23:30'


# Food Category form
class FoodCatInfoForm(forms.ModelForm):
    name = forms.CharField(widget=forms.TextInput(attrs={'class': 'form-control', 'required': 'required'}),
                           max_length=50,
                           error_messages={'required': 'This field is required.'})

    name_cn = forms.CharField(widget=forms.TextInput(attrs={'class': 'form-control', 'required': 'required'}),
                              max_length=50,
                              error_messages={'required': 'This field is required.'})

    class Meta:
        model = FoodCategories
        fields = ('name', 'name_cn')

    def __init__(self, *args, **kwargs):
        super(FoodCatInfoForm, self).__init__(*args, **kwargs)

src/mobile/server/templates/foods/edit.html
{% extends "base.html" %}

{% block extrahead %}
    {% load staticfiles %}
{% endblock %}

{% block title %}Edit Foods{% endblock %}
{% block food_active %}active{% endblock %}
{% block parent_food_a_active %}active{% endblock %}
{% block parent_food_i_active %}active{% endblock %}

{% block content %}
<div class="row">
    <div class="col-lg-12">
        <section class="panel panel-content">
            <header class="panel-heading">
                <span>Edit Food</span>
            </header>
            <div class="panel-body">
                <form class="form-horizontal" action="" role="form" method="post"
                      enctype="multipart/form-data">
                    {% csrf_token %}

                    <div class="form-group">
                        <label for="account_group" class="col-lg-2 col-sm-2 control-label">Category<span
                                class="span-required">(*)</span></label>
                        <div class="col-lg-10">
                            {{ form_info.category }}
                        </div>
                    </div>
                    <div class="form-group hidden">
                        <label for="subject" class="col-lg-2 col-sm-2 control-label">Type<span
                                class="span-required">(*)</span></label>
                        <div class="col-lg-10">
                            {{ form_info.type }}
                        </div>
                    </div>
                    <div class="form-group">
                        <label for="name" class="col-lg-2 col-sm-2 control-label">Name<span
                                class="span-required">(*)</span></label>
                        <div class="col-lg-10">
                            {{ form_info.name }}
                        </div>
                    </div>
                    <div class="form-group">
                        <label for="subject_cn" class="col-lg-2 col-sm-2 control-label">Name_CN<span
                                class="span-required">(*)</span></label>
                        <div class="col-lg-10">
                            {{ form_info.name_cn }}
                        </div>
                    </div>
                    <div class="form-group">
                        <label for="body" class="col-lg-2 col-sm-2 control-label">Price<span
                                class="span-required">(*)</span></label>
                        <div class="col-lg-10">
                            {{ form_info.price }}
                        </div>
                    </div>
                    <div class="form-group">
                        <label for="subject_cn" class="col-lg-2 col-sm-2 control-label">Description</label>
                        <div class="col-lg-10">
                            {{ form_info.description }}
                        </div>
                    </div>
                    <div class="form-group">
                        <label for="body_cn" class="col-lg-2 col-sm-2 control-label">Description_CN</label>
                        <div class="col-lg-10">
                            {{ form_info.description_cn }}
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-md-6">
                            <div class="form-group ">
                                <label for="start_time" class="col-lg-4 col-sm-4 control-label">Start Time<span
                                        class="span-required">(*)</span></label>
                                <div class="col-lg-8">
                                    {{ form_info.start_time }}
                                    <span id="lbTimeError" class="text-danger hidden">* Please input start time smaller then end time.</span>
                                </div>
                            </div>
                        </div>
                        <div class="col-md-6">
                            <div class="form-group ">
                                <label for="end_time" class="col-lg-4 col-sm-4 control-label">End Time<span
                                        class="span-required">(*)</span></label>
                                <div class="col-lg-8">
                                    {{ form_info.end_time }}
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="form-group">
                        <label for="hash_tags" class="col-lg-2 col-sm-2 control-label">Hash Tags</label>
                        <div class="col-lg-10">
                            {{ form_info.hash_tags }}
                            <span class="text-primary">* Please input as format: #hashtag1 #hastag2 #hastag3</span>
                        </div>
                    </div>
                    <div class="form-group">
                        <label for="week_days" class="col-lg-2 col-sm-2 control-label">Apply Days</label>
                        <div class="col-lg-10">
                            {{ form_info.week_days }}
                        </div>
                    </div>
                    <div class="row hidden">
                        <div class="col-md-6">
                            <div class="form-group ">
                                <label for="open_date" class="col-lg-4 col-sm-4 control-label">Quantity per Day</label>
                                <div class="col-lg-8">
                                    {{ form_info.quantity_per_day }}
                                </div>
                            </div>
                        </div>
                        <div class="col-md-6">
                            <div class="form-group ">
                                <label for="close_date" class="col-lg-4 col-sm-4 control-label">Current Order</label>
                                <div class="col-lg-8">
                                    {{ form_info.current_order }}
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="form-group">
                        <label for="image_path" class="col-lg-2 col-sm-2 control-label">Image</label>
                        <div class="col-lg-4">
                            {% if foods.image_path %}
                                <input id="image_path"
                                    name="image_path"
                                    class="dropify image_path"
                                    data-default-file="{% static 'media/' %}{{ foods.image_path }}"
                                    type="file"
                                    data-max-file-size="3M"
                                    data-show-remove="false"
                                    data-min-width="400"
                                    data-max-width="1080"
                                    data-allowed-file-extensions="png jpg jpeg"/>
                                <p class="text-primary">* Please choose image with width between 400px and 1080px</p>
                            {% else %}
                                <input required id="image_path"
                                    name="image_path"
                                    class="dropify image_path"
                                    type="file"
                                    data-max-file-size="3M"
                                    data-show-remove="false"
                                    data-min-width="400"
                                    data-max-width="1080"
                                    data-allowed-file-extensions="png jpg jpeg"/>
                                <p class="text-primary">* Please choose image with width between 400px and 1080px</p>
                            {% endif %}
                        </div>
                    </div>
                    <div class="form-group hidden">
                        <div class="col-lg-2">

                        </div>
                        <div class="col-lg-10">
                            <div class="checkbox checkbox-primary">
                                <input name="isDelete" id="checkbox-03" class="styled" type="checkbox"
                                       {% if foods.is_delete == 0 %}checked{% endif %}/>
                                <label for="checkbox-03">
                                    Active
                                </label>
                            </div>
                        </div>
                    </div>

                    <!--end form content-->
                    <div class="form-group bottom-group">
                        <div class="col-lg-offset-2 col-lg-10">
                            <button type="submit" class="btn btn-success" onclick="return checkTime()">Update</button>
                            <a type="submit" class="btn btn-default" href="{% url 'foods_list' %}">Cancel</a>
                        </div>
                    </div>

                </form>
            </div>
        </section>
    </div>
</div>
{% endblock %}

{% block extrafoot %}
    {% load staticfiles %}
    <script src="{% static 'assets/datatables/js/jquery.dataTables.min.js' %}"></script>
    <script src="{% static 'assets/datatables/js/dataTables.bootstrap.min.js' %}"></script>
    <!--dynamic table initialization -->
    <script src="{% static 'js/dynamic_table_init.js' %}"></script>
    <script>
        function checkTime() {
            var start_time = $("#id_start_time").val();
            var end_time = $("#id_end_time").val();

            if(end_time < start_time || end_time == start_time) {
                $("#lbTimeError").removeClass("hidden");
                return false;
            } else {
                $("#lbTimeError").addClass("hidden");
            }
        }

{#        $('#id_name').on('blur', function () {#}
{#            $.ajax({#}
{#                type: "POST",#}
{#                url: "{% url 'check_duplicate_food_name' %}",#}
{#                success: function (res) {#}
{#                    // TODO#}
{#                }#}
{#            });#}
{#        });#}
    </script>
{% endblock %}